/*------------------------------------------------------------------------------
* Alpha Shooter
* A 3D OpenGL First-Person Shooter game
* Copyright (C) 2005, 2006, 2007 Nicola Cocchiaro <ncocchiaro@users.sf.net>
* Alpha Shooter can be found at http://www.sf.net/projects/alphashooter.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 or, (at your option) any later
* version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*-------------------------------------------------------------------------------
*/


// controls.h
// controls input header file

#ifndef ALPSHOOT_CONTROLS_H
#define ALPSHOOT_CONTROLS_H

#include "main.h"
#include "lib.h"
#include "camera.h"
#include "display.h"

/* number of mouse modes */
#define MOUSE_MODES		3
/* mouse view modes */
#define MOUSE_NONE		0
#define MOUSE_PROGRESSIVE	1
#define MOUSE_PERSISTENT	2

// movement key mappings for movement check
#define KEY_FW		0
#define KEY_BACK	1
#define KEY_LEFT	2
#define KEY_RIGHT	3
#define KEY_UP		4
#define KEY_DOWN	5
#define KEY_ROLL_LT	6
#define KEY_ROLL_RT	7
#define KEY_ROT_LT	8
#define KEY_ROT_RT	9

#define SKEY_ROT_LT	0
#define SKEY_ROT_RT	1
#define SKEY_ROT_UP	2
#define SKEY_ROT_DN	3
#define SKEY_ROLL_LT	4
#define SKEY_ROLL_RT	5

void lights_off();
void lights_on();
void menuStatus(int status, int x, int y);
void menuSelect(int value);
void keyboard_handler(unsigned char key, int x, int y);
void special_handler(int key, int x, int y);
void release_key_handler(unsigned char key, int x, int y);
void special_release_handler(int key, int x, int y);
void check_for_movement();
void mouse_handler(int button, int s, int x, int y);
// void motion_handler(int x, int y);
void passive_handler(int x, int y);

extern int res[MAX_RES][2];

#endif
