/*------------------------------------------------------------------------------
* Alpha Shooter
* A 3D OpenGL First-Person Shooter game
* Copyright (C) 2005, 2006, 2007 Nicola Cocchiaro <ncocchiaro@users.sf.net>
* Alpha Shooter can be found at http://www.sf.net/projects/alphashooter.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 or, (at your option) any later
* version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*-------------------------------------------------------------------------------
*/

// quatlib.h
// a simple quaternion library

#ifndef ALPSHOOT_QUATLIB_H
#define ALPSHOOT_QUATLIB_H

#include <math.h>
#include "defs.h"

quaternion q_conjugate(quaternion q);
GLdouble q_magnitude(quaternion q);
quaternion q_normalize(quaternion q);
quaternion q_inverse(quaternion q);
quaternion q_multiply(quaternion q, quaternion r);
void q_convert_m(quaternion q, GLdouble m[16]);
quaternion aa_convert_q(vector axis, GLdouble angle);
vector q_convert_aa(quaternion q, GLdouble *angle);
quaternion v_convert_q(vector v);
void apply_q2v(quaternion q, vector *v);

#endif
